
/**
 * AgentWorld.java
 *
 *
 * Created: Tue Jul 04 12:19:04 2000
 *
 * @author 
 * @version
 */
package algae.simulation.worlds;

import algae.simulation.agents.Agent;
import algae.simulation.Settings;
import algae.simulation.view.ViewAgent;
import java.util.Random;
import java.lang.Object;
import java.util.*;

public class AgentWorld extends algae.simulation.worlds.World {
   
    public Vector agents=new Vector(100,1);
    public int agentCount;
    public int MAX_AGENTS;

    public SubstrateWorld sw;
    public LightWorld lw;
    public PheromoneWorld pw;

    Settings cfg;
    Random rand;
  
    public int stepDeadCount = 0;
    public int stepMeiosisCount = 0;
    public int stepMitosisCount = 0;
    public int stepSubstrateUsed = 0;
    public int stepSubstrateNew = 0;
    public int stepPheromoneUsed = 0;
    public int stepPheromoneNew = 0;
    public int stepLightUsed = 0;
    
    class Element extends World.Element
    {
	final double NOTHING = 0.0; 
	
	// Constructors
	public Element()
	    {
		this.amount = NOTHING;

	    }
	
	// Operations
	
	public boolean exists()
	    {
		return (this != null && this.amount > 0);
	    }
	
	public boolean add(int steps) 
	    {
	    	return true;
	    } //deplete
	
	public boolean remove(int steps)
	{
		return true;
	}
	
	boolean update()
	    {
		return true;
	    } // update
	
    }// end class Element

    public void initAgents()
    {
   	Agent tmp;
	rand=new Random(cfg.randSeed);
	System.out.println("inserting and initializing "+agentCount+" agents... - this may take a while..."); 
	for (int i=0; i<agentCount; i++)
	{
	     int ix=Math.abs(rand.nextInt()%cfg.width);
	     int iy=Math.abs(rand.nextInt()%cfg.height);
	     
	     tmp=new Agent(ix,iy,cfg,rand,this,sw,pw,lw);     
	     
	     while (this.world[tmp.y][tmp.x].amount!=0)
	     {
	     	tmp.x=Math.abs(rand.nextInt()%cfg.width);
	     	tmp.y=Math.abs(rand.nextInt()%cfg.height);
	     }
	     
	     this.world[tmp.y][tmp.x].amount=(double)(i+1);
	     agents.add(tmp);
	}
	System.out.println("initial algaes set and initialized");
    }

    public AgentWorld(Settings set, SubstrateWorld s, 
                      PheromoneWorld p, LightWorld l) {
	super(set.height,set.width);
	MAX_AGENTS = set.height*set.width;
	cfg=set;
	agentCount=cfg.initial_algaes;

	pw=p;
	sw=s;
	lw=l;
	
	for (int i=0; i<cfg.width; i++)
	    for (int j=0; j<cfg.height; j++)
	        this.world[j][i]=new Element();

	// the world can't hold more algaes, than fit into the aqua
	if (agentCount>MAX_AGENTS)
	   agentCount=MAX_AGENTS;

	initAgents();
    }
        
    int findNeighbour(int nOf, Agent a, boolean empty)
    {
    	if (empty)
    	{
    	    // search for an empty field to place a new agent into it
    	    
    	    // search for an algae on the left side
    	    if (a.x-1>=0)
    	       if (this.world[a.y][a.x-1].amount==0.0f)
    	       {
    	   	   return 1; // indicate free place : left
    	       }  
    	    // search for an algae on the right side
    	    if (a.x+1<cfg.width)
    	       if (this.world[a.y][a.x+1].amount==0.0f)
    	       {
    	   	   return 2; // indicate free place : right
    	       }  
    	    // search for an algae above
    	    if (a.y-1>=0)
    	       if (this.world[a.y-1][a.x].amount==0.0f)
    	       {
    	   	   return 3; // indicate free place : above
    	       }  
    	    // search for an algae above
    	    if (a.y+1<cfg.height)
    	       if (this.world[a.y+1][a.x].amount==0.0f)    
    	       {
    	   	   return 4; // indicate free place : below
    	       }
    	    // left upper 
    	    if ((a.x-1>=0)&&(a.y-1>=0))
    	       if (this.world[a.y-1][a.x-1].amount==0.0f)
    	       {
    	   	   return 5; // indicate : left upper
    	       }  
    	    // right upper
    	    if ((a.x+1<cfg.width)&&(a.y-1>=0))
    	       if (this.world[a.y-1][a.x+1].amount==0.0f)
    	       {
    	   	   return 6; // indicate: right upper
    	       }  
    	    // left lower
    	    if ((a.x-1>=0)&&(a.y+1<cfg.height))
    	       if (this.world[a.y+1][a.x-1].amount==0.0f)
    	       {
    	   	   return 7; // left lower
    	       }  
    	    // right lower
    	    if ((a.x+1<cfg.width)&&(a.y+1<cfg.height))
    	       if (this.world[a.y+1][a.x+1].amount==0.0f)
    	       {
    	   	   return 8; // right lower
    	       }
	}
	else
	{
    	    // search for a non-empty field to find a potential
    	    // agent for sexual reproduction
    	    // search for an algae on the left side
    	    //System.out.print(".");
    	    if (a.x-1>=0)
    	       if ((this.world[a.y][a.x-1].amount>0.0f)&&
    	           (this.world[a.y][a.x-1].amount!=nOf))
    	       {
    	   	   return (int)(world[a.y][a.x-1].amount-1);
    	       }  
    	    // search for an algae on the right side
    	    //System.out.print(".");
    	    if (a.x+1<cfg.width)
    	       if ((this.world[a.y][a.x+1].amount>0.0f)&&
    	           (this.world[a.y][a.x+1].amount!=nOf))
    	       {
    	   	   return (int)(world[a.y][a.x+1].amount-1);
    	       }  
    	    // search for an algae above
    	    //System.out.print(".");
    	    if (a.y-1>=0)
    	       if ((this.world[a.y-1][a.x].amount>0.0f)&&
    	           (this.world[a.y-1][a.x].amount!=nOf))
    	       {
    	   	   return (int)(world[a.y-1][a.x].amount-1);
    	       }  
    	    // search for an algae above
    	    //System.out.print(".");
    	    if (a.y+1<cfg.height)
    	       if ((this.world[a.y+1][a.x].amount>0.0f)&&
    	           (this.world[a.y+1][a.x].amount!=nOf))
    	       {
    	   	   return (int)(world[a.y+1][a.x].amount-1);
    	       }
    	    // left upper 
    	    //System.out.print(".");
    	    if ((a.x-1>=0)&&(a.y-1>=0))
    	       if ((this.world[a.y-1][a.x-1].amount>0.0f)&&
    	           (this.world[a.y-1][a.x-1].amount!=nOf))
    	       {
    	   	   return (int)(world[a.y-1][a.x-1].amount-1);
    	       }  
    	    // right upper
    	    //System.out.print(".");
    	    if ((a.x+1<cfg.width)&&(a.y-1>=0))
    	       if ((this.world[a.y-1][a.x+1].amount>0.0f)&&
    	           (this.world[a.y-1][a.x+1].amount!=nOf))
    	       {
    	   	   return (int)(world[a.y-1][a.x+1].amount-1);
    	       }  
    	    // left lower
    	    //System.out.print(".");
    	    if ((a.x-1>=0)&&(a.y+1<cfg.height))
    	       if ((this.world[a.y+1][a.x-1].amount>0.0f)&&
    	           (this.world[a.y+1][a.x-1].amount!=nOf))
    	       {
    	   	   return (int)(world[a.y+1][a.x-1].amount-1);
    	       }  
    	    // right lower
    	    //System.out.print(".");
    	    if ((a.x+1<cfg.width)&&(a.y+1<cfg.height))
    	       if ((this.world[a.y+1][a.x+1].amount>0.0f)&&
    	           (this.world[a.y+1][a.x+1].amount!=nOf))
    	       {
    	   	   return (int)(world[a.y+1][a.x+1].amount-1);
    	       }
    	}  
   	return -1;
    }
    
    public int move(Agent tmp, int sel)
    {
    	int ox=tmp.x;
    	int oy=tmp.y;
    	// and decide what to do (movement)
	     	switch (sel)
	     	{
	     	     // stand still
	     	     case 0: // do nothing
	     	             break;
	     	             
	     	     // go right
	     	     case 1: if (tmp.x<cfg.width-1) 
	     	     		if (this.world[tmp.y][tmp.x+1].amount==0)
	     	     		    tmp.x++;
	     	     		    
	     	     	     tmp.dir=1;
	     		     tmp.energy_level-=cfg.energy_movement;
	     		     break;
	     		     
	     	     // go down
	     	     case 2: if (tmp.y<cfg.height-1) 
	     	     		if (this.world[tmp.y+1][tmp.x].amount==0)
	     	     		    tmp.y++;

	     		     tmp.dir=2;
	     		     tmp.energy_level-=cfg.energy_movement;
	     		     break;
	     		     
	     	     // go left
	     	     case 3: if (tmp.x>0) 
	     	     		if (this.world[tmp.y][tmp.x-1].amount==0)
	     	     		    tmp.x--;

	     		     tmp.dir=3;
	     		     tmp.energy_level-=cfg.energy_movement;
	     		     break;
	     	     
	     	     // go up
	     	     case 4: if (tmp.y>0) 
	     	     		if (this.world[tmp.y-1][tmp.x].amount==0)
	     	     		    tmp.y--;

	     		     tmp.dir=4;
	     		     tmp.energy_level-=cfg.energy_movement;
	     		     break;
	     	}		
	        
	        if (tmp.energy_level<=0.0f)
	        {
	           tmp.dead=true;
	           this.world[oy][ox].amount=0;
	 	   this.world[tmp.y][tmp.y].amount=0;
	           return -1; // indicate that the agent died
	        }  
	 
	 this.world[oy][ox].amount=0;
	 lw.update(ox,oy,tmp.x,tmp.y);
	 return 0;
	        
    }
    
    public int doPheromoneOutput(Agent tmp)
    {
	 pw.world[tmp.y][tmp.x].add(0); 
	 tmp.energy_level-=cfg.energy_pheromone_output;
	 
	 if (tmp.energy_level<=0.0f)
	 {
	     tmp.dead=true;
	     this.world[tmp.y][tmp.x].amount=0;
	     return -1; // agent died
	 }  
	 return 0;	        
    }
    
    // move, update (position, consume substrate) and populate the agents 
    public void step(int steps)
    {
	stepDeadCount = 0;
        stepMeiosisCount = 0;
        stepMitosisCount = 0;
        stepSubstrateUsed = 0;
        stepSubstrateNew = 0;
    	stepPheromoneUsed = 0;
    	stepPheromoneNew = 0;
    	stepLightUsed = 0;
	
	lw.used=0;
	lw.renew=0;
	
	sw.used=0;
	sw.renew=0;
	
	pw.used=0;
	pw.renew=0;
        	
    	Agent tmp;
    	int newAgentCount=agentCount;
                        
	for (int z=0; z<agentCount; z++)
	{
	    // get a reference to actual agent
	    tmp=(Agent)agents.elementAt(z);
	    
	    // process alive agents only
	    if (tmp.isAlive())
	    {
	    	// reset several flags used for statistics
	    	tmp.madeMeiosis=false;
	    	tmp.madeMitosis=false;
	    	tmp.usedSubstrate=false;
	    	tmp.usedLight=false;
	    	tmp.died=false;
	    	tmp.born=false;
	    	
	    	// process neural network
	     	int res=tmp.calcStep();
		
	     	// move the agent according to the ann-output
	     	if (move(tmp,res)==-1)
	     	{
	     	   System.out.println("agent #"+z+" died");
	     	   stepDeadCount++;
	     	   tmp.died=true;
	           continue;
	        }
	        else
	        {
	           this.world[tmp.y][tmp.x].amount=z+1;
	        }
	     	
	        // throw out some pheromone
	        if (doPheromoneOutput(tmp)==-1)
	        {   
	           System.out.println("agent #"+z+" died");
	           stepDeadCount++;
	           tmp.died=true;
	           continue;
	        }
	        	        
	        // look out for substrate at an agents' position
	        if (sw.world[tmp.y][tmp.x].remove(0))
	        {
	            tmp.energy_level+=cfg.energy_substrate;
	            stepSubstrateUsed++;	            
	            tmp.usedSubstrate=true;
	        }
	        
	        // consume some light
	        if (lw.consume(tmp.x,tmp.y)>0)
	        {
	            tmp.energy_level+=cfg.energy_light;
	            stepLightUsed++;
	            tmp.usedLight=true;
	        }	        
	           
	        // process population (mitosis,meiosis)     
	             
	        // first of all find a partner
	        int nb=findNeighbour(z+1,tmp,false);
	        
	        // partner found and enough energy for meiosis
	        if ((tmp.energy_level>=cfg.energy_meiose*2.0f)&&(nb!=-1))
	        {
	            Agent tmpAgent=(Agent)agents.elementAt(nb);
	            Agent newAgent=new Agent(tmp,tmpAgent,0.2f,0.1f,cfg,rand);
	            stepMeiosisCount++;

	            newAgentCount++;
	            newAgent.born=true;
	            agents.add(newAgent);
	            
	            tmp.madeMeiosis=true;
	            tmpAgent.madeMeiosis=true;
	            	            
	            newAgent.madeMeiosis=false;
	    	    newAgent.madeMitosis=false;
	    	    newAgent.usedSubstrate=false;
	    	    newAgent.usedLight=false;
	    	    newAgent.died=false;
	    	    newAgent.born=false;
	    		            
	            // test if tmpAgent died during meiosis
	            if (tmpAgent.energy_level<=0.0f)
	            {
	            	tmpAgent.dead=true;
	            	System.out.println("agent #"+nb+" died during MEIOSIS\n");
	            	this.world[tmpAgent.y][tmpAgent.x].amount=0;
	            	stepDeadCount++;
	            	tmpAgent.died=true;
	            }
	        
	            int freeDir=findNeighbour(0,tmp,true);
	            
	            if (freeDir!=-1)
	            {
	            	switch (freeDir) {
	                   case 1: newAgent.x=tmp.x-1;
	                   	   newAgent.y=tmp.y;
	                   	   break;
	                   case 2: newAgent.x=tmp.x+1;
	                   	   newAgent.y=tmp.y;
	                   	   break;
	                   case 3: newAgent.x=tmp.x;
	                   	   newAgent.y=tmp.y-1;
	                   	   break;
	                   case 4: newAgent.x=tmp.x;
	                   	   newAgent.y=tmp.y+1;
	                   	   break;
	                   case 5: newAgent.x=tmp.x-1;
	                   	   newAgent.y=tmp.y-1;
	                   	   break;
	                   case 6: newAgent.x=tmp.x+1;
	                   	   newAgent.y=tmp.y-1;
	                   	   break;
	                   case 7: newAgent.x=tmp.x-1;
	                   	   newAgent.y=tmp.y+1;
	                   	   break;
	                   case 8: newAgent.x=tmp.x+1;
	                   	   newAgent.y=tmp.y+1;
	                   	   break;
	                   }	          	
	                   if (this.world[newAgent.y][newAgent.x].amount==0.0f)
	                       this.world[newAgent.y][newAgent.x].amount=newAgentCount;
	                   else
	                       System.out.println("Positioning error [MEIOSIS 1] - should really never happen");
	            }
	            else
	            if (tmpAgent.dead==true)
	            {
	            	newAgent.x=tmpAgent.x;
	            	newAgent.y=tmpAgent.y;

			System.out.println("MEIOSIS: newAgent X/Y: "+newAgent.x+"/"+newAgent.y);	          	
	                System.out.println("MEIOSIS: newAgent Value in aWorld = "+this.world[newAgent.y][newAgent.x].amount);	          	
	                        
	                if (this.world[newAgent.y][newAgent.x].amount==0.0f)
	                    this.world[newAgent.y][newAgent.x].amount=newAgentCount;
	                else
	                    System.out.println("Positioning error [MEIOSIS 2] - should really never happen");
	            }
	            else
	            {
	            	freeDir=findNeighbour(0,tmpAgent,true);
	            
	                if (freeDir!=-1)
	            	{
	            	     switch (freeDir) {
	                   	case 1: newAgent.x=tmpAgent.x-1;
	                   	   	newAgent.y=tmpAgent.y;
	                   	   	break;
	                   	case 2: newAgent.x=tmpAgent.x+1;
	                   	   	newAgent.y=tmpAgent.y;
	                   	   	break;
	                   	case 3: newAgent.x=tmpAgent.x;
	                   	   	newAgent.y=tmpAgent.y-1;
	                   	   	break;
	                   	case 4: newAgent.x=tmpAgent.x;
	                   	   	newAgent.y=tmpAgent.y+1;
	                   	   	break;
	                   	case 5: newAgent.x=tmpAgent.x-1;
	                   	   	newAgent.y=tmpAgent.y-1;
	                   	   	break;
	                   	case 6: newAgent.x=tmpAgent.x+1;
	                   	   	newAgent.y=tmpAgent.y-1;
	                   	   	break;
	                   	case 7: newAgent.x=tmpAgent.x-1;
	                   	   	newAgent.y=tmpAgent.y+1;
	                   	   	break;
	                   	case 8: newAgent.x=tmpAgent.x+1;
	                   	   	newAgent.y=tmpAgent.y+1;
	                   	   	break;
	                   	}	          	
	                   	
	                   	System.out.println("MEIOSIS: newAgent X/Y: "+newAgent.x+"/"+newAgent.y);	          	
	                        System.out.println("MEIOSIS: newAgent Value in aWorld = "+this.world[newAgent.y][newAgent.x].amount);	          	
	                        	                   	
	                        if (this.world[newAgent.y][newAgent.x].amount==0.0f)
	                            this.world[newAgent.y][newAgent.x].amount=newAgentCount;
	                        else
	                            System.out.println("Positioning error [MEIOSIS 3] - should really never happen");
	            	}
	            	else
	            	{
	            	    // hmm, there is no free place around
	            	    // let the new agent die
	            	    newAgent.dead=true;
	            	    System.out.println("MEIOSIS: new agent died because of no placement choice\n");
	            	    stepDeadCount++;
	            	    newAgent.died=true;
	            	}
	            }
            	            	            
	            System.out.println("MEIOSIS: new agent added" +newAgentCount);
	            // energy_level for the involved agents 
	            // already updated in mitosis-function
	            
	        }
		else
		   // no partner found or not enough energy for meiosis 
		     // -> mitosis (if enough energy available)
		if (tmp.energy_level>=cfg.energy_mitose*2.0f)
	        {
	            Agent newAgent=new Agent(tmp,0.1f,cfg,rand);
	            newAgentCount++;
	            agents.add(newAgent);
	            stepMitosisCount++;
	            
	            newAgent.madeMeiosis=false;
	    	    newAgent.madeMitosis=false;
	    	    newAgent.usedSubstrate=false;
	    	    newAgent.usedLight=false;
	    	    newAgent.died=false;
	    	    newAgent.born=false;
	    			            
	            tmp.madeMitosis=true;
	            
	            System.out.println("MITOSIS: new agent added" +newAgentCount);
	                 
	            int freeDir=findNeighbour(0,tmp,true);
	            
	            if (freeDir!=-1)
	            {
	            	switch (freeDir) {
	                   	case 1: newAgent.x=tmp.x-1;
	                   	   	newAgent.y=tmp.y;
	                   	   	break;
	                   	case 2: newAgent.x=tmp.x+1;
	                   	   	newAgent.y=tmp.y;
	                   	   	break;
	                   	case 3: newAgent.x=tmp.x;
	                   	   	newAgent.y=tmp.y-1;
	                   	   	break;
	                   	case 4: newAgent.x=tmp.x;
	                   	   	newAgent.y=tmp.y+1;
	                   	   	break;
	                   	case 5: newAgent.x=tmp.x-1;
	                   	   	newAgent.y=tmp.y-1;
	                   	   	break;
	                   	case 6: newAgent.x=tmp.x+1;
	                   	   	newAgent.y=tmp.y-1;
	                   	   	break;
	                   	case 7: newAgent.x=tmp.x-1;
	                   	   	newAgent.y=tmp.y+1;
	                   	   	break;
	                   	case 8: newAgent.x=tmp.x+1;
	                   	   	newAgent.y=tmp.y+1;
	                   	   	break;
	                   	}
	                        if (this.world[newAgent.y][newAgent.x].amount==0.0)
	                            this.world[newAgent.y][newAgent.x].amount=newAgentCount;
	                   	else
	                       	    System.out.println("Positioning error [MITOSIS 1] - should really never happen");
	            }
	            else
	            {
	                 // hmm, there is no free place around
	                 // let the new agent die
	                 // --> die
	                 newAgent.dead=true;
	                 newAgent.died=true;
	                 stepDeadCount++;
	                 System.out.println("MITOSIS: new agent died because of no placement choice\n");
	            }
	        }
	    }
	}
	agentCount=newAgentCount;
    }
    
    public int aliveAgents()
    {
    	Agent tmp;
    	
    	int retC=0;
    	for (int z=0; z<agentCount; z++)
    	{
    	     tmp=(Agent)agents.elementAt(z);
    	     
    	     if (tmp.isAlive())
    	     	 retC++;
     	}
     	
     	return retC;
    }
    
    public ViewAgent[] getList()
    {
    	Agent tmp;
    	
    	int retC=0;
    	for (int z=0; z<agentCount; z++)
    	{
    	     tmp=(Agent)agents.elementAt(z);
    	     
    	     if (tmp.isAlive())
    	     	 retC++;
     	}
     	
     	if (retC==0)
     	   return null;
     	
     	ViewAgent retVal[] = new ViewAgent[retC];
    	
    	int i=0;
    	
    	for (int z=0; z<agentCount; z++)
    	{
    	     tmp=(Agent)agents.elementAt(z);
    	     
    	     if (tmp.isAlive())
    	     {
    	     	 retVal[i]=new ViewAgent(tmp.x,tmp.y,z,tmp.dir);
    	     	 i++;  
             };
     	}
     	
     	return retVal;
    }
    
} // AgentWorld
