package algae.simulation.worlds;
import java.util.*;

import algae.simulation.Settings;
import algae.simulation.view.ViewPheromone;
import java.io.IOException;
/** A class that represents ...
 * 
 * @see OtherClasses
 * @author your_name_here
 */
public class PheromoneWorld extends World {
  
    final double RESOLVERATE;
    
    class Element extends World.Element
    {
	final double NOTHING = 0.0; 
	
	int stepsToResolve;
	
	// Constructors
	public Element()
	    {
		this.amount = NOTHING;
		this.stepsToResolve = 0;
	    }
	
	public Element(double amount, int dec)
	    {
		this.amount = amount;
		this.stepsToResolve = dec;
	    }
	
	// Operations
	
	public boolean exists()
	    {
		return ((this != null) && (this.amount > 0));
	    }
	
	public boolean add(int steps) 
	    {
	    	this.amount += 1.0;
		this.stepsToResolve = (int)(1/RESOLVERATE);
		renew++;
		return true;
		
	    } //deplete
	
	public boolean remove(int steps)
	{
		return true;
	}
	
	boolean update()
	    {
	    	if (this.amount<=0)
	    	   return true;
		if (this.stepsToResolve>0)
		{
		    stepsToResolve--;
		}
		else 
		{
		    this.amount--;
		    used++;
		    stepsToResolve=(int)(1/RESOLVERATE);
		}
		return true;
	    } // update
	
    }// end class Element
    
    public PheromoneWorld(Settings set) 
    {
	super(set.height, set.width);
	cfg=set;
	this.RESOLVERATE = set.pheromone_dec_rate;
        
        for (int i=0; i<set.height; i++)
            for (int j=0; j<set.width; j++)
                this.world[i][j]=new Element(0.0,0);
    }

    public void set(int x, int y)
    {
    	if (this.world[y][x].add(1))
	   return;
	else
	   return;
    }

    public void step(int step)
    {
	for(int i = 0; i < cfg.height; i++) 
	    {	    
		for(int j = 0; j < cfg.width;j++) 
		    {
			  this.world[i][j].update();
		    }
	    }
    }

    public ViewPheromone[]  getList()
    {
	ViewPheromone ret[];
	int retC=0;
	
	for(int i = 0; i < cfg.height;i++) 
	    {
		for(int j = 0; j < cfg.width;j++) 
		    {
			if (this.world[i][j].amount>0.0)
			    retC++;
		    }
	    }
	
	int z=0;
	
	if (retC==0)
	   return null;
	
	ret=new ViewPheromone[retC];
	
	for(int i = 0; i < cfg.height;i++) 
	    {
		for(int j = 0; j < cfg.width;j++) 
		    {
			if (this.world[i][j].amount>0.0)
		        {
			    ret[z]=new ViewPheromone(j,i,this.world[i][j].value(j,i));
			    z++;
			}
		    }
	    }
	return ret;
    }//getList

  // Operations

} /* end class PheromoneWorld */
