package algae.simulation.worlds;

import java.util.*;
import algae.simulation.Settings;
import algae.simulation.view.ViewSubstrate;
/** A class that represents ...
 * 
 * @see OtherClasses
 * @author your_name_here
 */
public class SubstrateWorld extends World 
{
    // Attributes
    final static double AMOUNT = 1000;

    public double amount;

    public final double RENEWRATE;
    
    class Element extends World.Element
    {
	final double NOTHING = 0.0; 
	
	int stepsToRegenerate;
	int stepsToGo;
	
	// Constructors
	public Element()
	    {
		this.amount = NOTHING;
		this.stepsToRegenerate = 0;
	    }
	
	public Element(double amount, int dec)
	    {
		this.amount = amount;
		this.stepsToRegenerate = dec;
		this.stepsToGo = dec;
	    }
	
	// Operations
	
	public boolean exists()
	    {
		return (this != null && this.amount > 0);
	    }
	
	public boolean add(int steps)
	{
		return true;
	}
	
	public boolean remove(int steps) 
	    {
		if(!this.exists())
		    {	
			return false; 
		    }
		else 
		    {
			this.amount -= 1.0;
			used++;
			this.stepsToRegenerate = (int) (1/RENEWRATE);
			return true;
		    }
	    } //deplete
	
	boolean update()
	    {
		if((this.stepsToRegenerate == 0)&&(this.amount<1))
		{
		    this.amount++;
		    this.stepsToRegenerate=this.stepsToGo;
		    renew++;
		}
		else 
		if (stepsToRegenerate!=-1)
		{
		    this.stepsToRegenerate--;
		}
		return true;
	    } // update
	
    }// end class Element


    public SubstrateWorld(Settings set) 
    {
	super(set.height, set.width);
	cfg=set;
	this.amount = set.substrate_amount;
	this.RENEWRATE = set.substrate_renew_rate;
	for(int i = 0; i < set.height;i++) 
	    {	    
		for(int j = 0; j < set.width;j++) 
		    {
		    	// TODO: take care of renew-rate
		    	//       and make distribution more fuzzy
			if (1/(1+(set.height-i)) == 1)
			{
			    //if (j%(1/(i+1)*(set.height/2))==0)
			       this.world[i][j] = new Element(1.0,(int)(set.height-i)*(int)(1/RENEWRATE));
			    //else
			    //   this.world[i][j] = new Element(0.0,-1);
			    
			}
			else
			{
			    //if (j%(1/(i+1)*(set.height/2))==0)
				this.world[i][j] = new Element(0.0,(int)(set.height-i)*(int)(1/RENEWRATE));
			    //else
			    //	this.world[i][j] = new Element(0.0,-1);
			}			    
		    }
	    }
    }//Substrate World


    public void step(int step)
    {
	for(int i = 0; i < cfg.height;i++) 
	    {	    
		for(int j = 0; j < cfg.width;j++) 
		    {
			 this.world[i][j].update();
		    }
	    }
    }

    public ViewSubstrate[] getList()
    {
	ViewSubstrate ret[];
	
	int retC=0;
	for(int i = 0; i < cfg.height; i++) 
	    {
		for(int j = 0; j < cfg.width;j++) 
		    {
		    	if (this.world[i][j].amount>0.0)
	                   retC++;
		    }
	    }
	   
	if (retC==0)
	   return null;
	    	    
	ret=new ViewSubstrate[retC];
	int z=0;
	
	this.amount=0;
	for(int i = 0; i < cfg.height;i++) 
	    {
		for(int j = 0; j < cfg.width;j++) 
		    {
			if(this.world[i][j].amount>0.0)
			{
			    ret[z]=new ViewSubstrate(j,i,this.world[i][j].value(j,i));
			    
			    this.amount=this.amount+this.world[i][j].value(j,i);
			    z++;
			}
		    }
	    }
	    
	return ret;
    }//getList
    
    public double getSubstrateAmount() {
	return this.amount;
    }

} /* end class SubstrateWorld */
